/** fMSX: portable MSX emulator ******************************/
/**                                                         **/
/**                          Help.h                         **/
/**                                                         **/
/** This file contains help information printed out by the  **/
/** main() routine when started with option "-help".        **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin 1994,1995                 **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify me, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/

#define NULL 0

char *HelpText[] =
{
  "Usage: fmsx [-option1 [-option2...]] [filename1] [filename2]",
  "[filename1] = name of file to load as cartridge A",
  "[filename2] = name of file to load as cartridge B",
  "[-option]   =",
  "  -verbose <level>    - Select debugging messages [1]",
  "                        0 - Silent       1 - Startup messages",
  "                        2 - V9938 ops    4 - Disk",
  "                        8 - Memory      16 - Illegal Z80 ops", 
  "  -ifreq <frequency>  - Set external interrupts frequency [off]",
  "  -iperiod <period>   - Set internal interrupts period [6000ops]",
  "  -uperiod <period>   - Number of interrupts per screen update [2]",
  "  -help               - Print this help page",
  "  -printer <filename> - Redirect printer output to file [stdout]",
#ifdef MITSHM
  "  -shm/-noshm         - Use/don't use MIT SHM extensions for X [-shm]",
#endif
  "  -ram <pages>        - Number of 16kB RAM pages [4/8/8]",
  "  -vram <pages>       - Number of 16kB VRAM pages [2/8/8]",
#ifdef DEBUG
  "  -trap <address>     - Trap execution when PC reaches address [FFFFh]",
#endif
  "  -msx1/-msx2/-msx2+  - Select MSX model [-msx1]",
  "  -rom <type>         - Select MegaROM mapper types [0,0]",
  "                        (two -rom options can be present)",
  "                        0 - Konami 8kB    1 - MSXDOS2 16kB",
  "                        2 - Konami5 8kB   3 - Konami4 8kB",
  "                        4 - ASCII 8kB     5 - ASCII 16kB",
  "  -diska <filename>   - Set disk image used for drive A: [DRIVEA.DSK]",
  "  -diskb <filename>   - Set disk image used for drive B: [DRIVEB.DSK]",
  "  -tape <filename>    - Set tape image file [off]",
  "  -font <filename>    - Set fixed font for text modes [DEFAULT.FNT]",
  "  -serial <filename>  - Redirect serial I/O to a file [stdin/stdout]",
  "  -logsnd <filename>  - Write soundtrack to a file [off]", 
#ifdef UNIX
  "  -saver/-nosaver     - Save/don't save CPU when inactive [-saver]",
#endif
#ifdef SOUND
  "  -sound/-nosound     - Play/don't play sound [-nosound]",
#endif
  NULL
};
