/* Small S3M player written as AICA firmware
 *
 * (c)2000 Dan Potter
 *
 * Notes on using:
 *
 * To use this player, you just need to load your S3M into sound RAM
 * at 0x10000, and then load this program into the ARM CPU. This program
 * will then parse the S3M into samples and tracks, etc, and start 
 * playing it. To stop the playback, use dc_snd_stop_arm() in libdream.
 */

/****************** Timer *******************************************/


/* volatile unsigned char *dc_snd_base = (unsigned char *)0x00800000; */
#define dc_snd_base ((volatile unsigned char *)0x00800000)

/* Some convienence macros */
#define SNDREG32A(x) ((volatile unsigned long *)(dc_snd_base + (x)))
#define SNDREG32(x) (*SNDREG32A(x))
#define SNDREG8A(x) (dc_snd_base + (x))
#define SNDREG8(x) (*SNDREG8A(x))
#define CHNREG32A(chn, x) SNDREG32A(0x80*(chn) + (x))
#define CHNREG32(chn, x) (*CHNREG32A(chn, x))
#define CHNREG8A(chn, x) SNDREG8A(0x80*(chn) + (x))
#define CHNREG8(chn, x) (*CHNREG8A(chn, x))

extern volatile int timer;

void timer_wait(int jiffies) {
	int fin = timer + jiffies;
	while (timer <= fin)
		;
}

void play_buf(void)
{
 aica_play(0, 0x10000, 0, 0, 1408, 22050, 0xFF, 0x80, 1);  
}

/****************** Main Program ************************************/

volatile unsigned long *pos = (unsigned long*)0xffc4;

int arm_main() 
{
   aica_init();
   
   SNDREG8(0x280d) = 0;
   /* Both buffers are ready to fill */
  //*first_ready = 1;
  //*second_ready = 1;
  
  /* start the sound */
  play_buf();
  *pos = 0;
  while(1)
    {
      *pos = SNDREG32(0x2814);
      timer_wait(2);
    }

}






